/*
	File:		MoMathComponentPrivate.h

	Contains:	Private header file for MoMath component routines.

	Written by:	Gary Woodcock

	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

*/

//-----------------------------------------------------------------------
// Includes

#ifndef	_MOMATHCOMPONENTPRIVATE_
#define	_MOMATHCOMPONENTPRIVATE_

#include <QuickTimeComponents.h>
#include "DebugFlags.h"

//-----------------------------------------------------------------------
// Private prototypes

#ifdef DEBUG_IT
					 
// Only need this prototype if we're running linked (for debugging)
pascal	ComponentResult	MoMathDispatcher	(ComponentParameters	*params,
											 Handle					storage);

#endif DEBUG_IT

pascal	ComponentResult	_MoMathCanDo		(short					selector);

pascal	ComponentResult	_MoMathDoAdd		(short					firstNum,
											 short					secondNum,
											 short					*additionResult);

//-----------------------------------------------------------------------

#endif	_MOMATHCOMPONENTPRIVATE_

//-----------------------------------------------------------------------
