#include "Pict.r"
#include "Types.r"

/* define a rects list resource type */
type 'RCT#' {
	integer = $$Countof(RectArray);
	array RectArray {
			rect;										/* String				*/
	};
};

resource 'RCT#' (128) { {
/* 0 */	{100, 10, 120, 85}, 	/* 'Duration = ' */
/* 1 */	{100, 90, 120,160},		/* duration */
/* 2 */	{100, 165, 120, 215},	/* scale	*/

/* 3 */	{175, 10, 195, 85},		/* 'Rate Settings' */

/* 4 */	{200, 10, 220, 85},		/* 'Current = ' */
/* 5 */	{200, 90, 220, 160},	/* rate			*/

/* 6 */	{225, 10, 245, 85},		/* 'Preferred = */
/* 7 */	{225, 90, 245, 160},	/* rate			*/

/* 8 */	{265, 10, 285, 215},	/* clock		*/

/* 9 */	{125, 10, 145, 85},		/* 'start time '*/
/* 10 */{125, 90, 145, 160},	/* starttime	*/

/* 11 */{150, 10, 170, 85},		/* 'stop time ' */
/* 12 */{150, 90, 170, 160},	/* stopTime  	*/

/* 13 */{230, 8, 340, 508},}	/* unused		*/
};


resource 'WIND' (128) {
	{40, 8, 340, 508},
	noGrowDocProc,
	visible,
	goAway,
	0x0,
	"TimeBaseSimple Window"
};

resource 'CNTL' (128) {
	{4, 10, 90, 126},
	0,
	visible,
	900,
	0,
	2048,
	0,
	""
};

resource 'CNTL' (129) {
	{4, 100, 20, 195},
	1,
	visible,
	1,
	0,
	radioButProc,
	0,
	"No looping"
};

resource 'CNTL' (130) {
	{22, 100, 38, 195},
	0,
	visible,
	1,
	0,
	radioButProc,
	0,
	"Yes looping"
};

resource 'CNTL' (131) {
	{40, 100, 56, 195},
	0,
	visible,
	1,
	0,
	radioButProc,
	0,
	"Palindrome"
};

resource 'CNTL' (132) {
	{225, 178, 245, 235},
	0,
	visible,
	1,
	0,
	pushButProc,
	0,
	"Set Rate"
};

resource 'CNTL' (133) {
	{225, 240, 245, 290},
	0,
	visible,
	1,
	0,
	pushButProc,
	0,
	"Reset"
};

resource 'PICT' (133) {
	{226, 162, 244, 173},
	VersionOne {
		{	/* array OpCodes: 2 elements */
			/* [1] */
			clipRgn {
				{-30000, -30000, 30000, 30000},
				$""
			},
			/* [2] */
			bitsRect {
				2,
				{226, 162, 244, 173},
				{226, 162, 244, 173},
				{226, 162, 244, 173},
				srcCopy,
				$"3F80 4040 8420 8E20 9F20 BFA0 8E20 8E20"
				$"8020 8020 8E20 8E20 BFA0 9F20 8E20 8420"
				$"4040 3F80"
			}
		}
	}
};

