//--------------------------------------------------------------------------
//
//		BetterFlattenMovie.
//			by John Wang
//
//		Description:	Better version of FlattenMovie and FlattenMovie Data.  Also
//						includes two routines for accessing movie resource atoms in
//						the data fork  (single-fork movies).
//
//		Version:	1.0		11/09/93	Completed for develop column.
//
//--------------------------------------------------------------------------

pascal void BetterFlattenMovie(Movie theMovie, long movieFlattenFlags, 
			FSSpec *theFile, OSType creator, ScriptCode scriptTag,
			long createMovieFileFlags, short *resId, const StringPtr resName);

pascal Movie BetterFlattenMovieData(Movie theMovie, long movieFlattenFlags, 
			FSSpec *theFile, OSType creator, ScriptCode scriptTag,
			long createMovieFileFlags);
			
OSErr CountMoviesInDataFork(FSSpec *theFile, short *count);
OSErr SearchMoviesInDataFork(FSSpec *theFile, short index, long *fileOffset);
